/*-------------------------------------------------------------------------+
| Copyright 2017 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.partitionmapping;

import java.util.Collection;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.partitionmapping.PartitionMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.MutateOperatorModuleBase;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IExecutionUnitAdapter;

/**
 * 
 * @author diewald
 */
public class PartitionMappingModule extends MutateOperatorModuleBase {
	/** {@link IExecutionUnitAdapter}s available as allocation targets. */
	Collection<IExecutionUnitAdapter<?>> executionUnits;

	/** Constructor. */
	public PartitionMappingModule(Collection<IExecutionUnitAdapter<?>> executionUnits) {
		this.executionUnits = executionUnits;
	}

	/** {@inheritDoc} */
	@Override
	public void config() {
		super.config();

		addOperatorInstance(PartitionMappingEncoding.class,
				new MutatePartitionDecrement(executionUnits));
		addOperatorInstance(PartitionMappingEncoding.class,
				new MutatePartitionIncrement(executionUnits));
	}
}
